// function for IR sensor with ELEGOO IR remote control ============================================

// Setting of the function =======================
//     IRrecc : 0=init IR sensor, 1 read the sensor and return value
//     if the sensor does not receive anything then " " is returned.
// End setting of the function =================== 

String IRrec (int IRrecc) {
String IRrect = " ";
    if (IRrecc != 0)
    {
      irrecv.resume(); // receive the next value
      delay(700);
      if (irrecv.decode(&results)) // have we received an IR signal?
      {
        switch(results.value)
        {
        case 0xFFA25D: IRrect=("POWER"); break;
        case 0xFFE21D: IRrect=("FUNC/STOP"); break;
        case 0xFF629D: IRrect=("VOL+"); break;
        case 0xFF22DD: IRrect=("FAST BACK");    break;
        case 0xFF02FD: IRrect=("PAUSE");    break;
        case 0xFFC23D: IRrect=("FAST FORWARD");   break;
        case 0xFFE01F: IRrect=("DOWN");    break;
        case 0xFFA857: IRrect=("VOL-");    break;
        case 0xFF906F: IRrect=("UP");    break;
        case 0xFF9867: IRrect=("EQ");    break;
        case 0xFFB04F: IRrect=("ST/REPT");    break;
        case 0xFF6897: IRrect=("0");    break;
        case 0xFF30CF: IRrect=("1");    break;
        case 0xFF18E7: IRrect=("2");    break;
        case 0xFF7A85: IRrect=("3");    break;
        case 0xFF10EF: IRrect=("4");    break;
        case 0xFF38C7: IRrect=("5");    break;
        case 0xFF5AA5: IRrect=("6");    break;
        case 0xFF42BD: IRrect=("7");    break;
        case 0xFF4AB5: IRrect=("8");    break;
        case 0xFF52AD: IRrect=("9");    break;
        }// End Case
      return(IRrect); 
    } // have we received an IR signal?
  } else{ irrecv.enableIRIn(); }
}  
