// https://www.zem.fr/decouverte-du-composant-74hc595-8-bit-shift-register/#codesyntax_1
// Function that uses the port extension feature 74HC595 ============================================
// Output may be 0 or 1 only

// Setting of the function =======================
//     Expin : 0=init 74HC595, 1 put all ports to LOW, 2 write out to 7hc595
// 
// for Expin = 2 the 74HC595 register will be updated with the values of the variables "setRegisterPin"
//  setRegisterPin(pinnum 0 to 7, LOW or HIGH);

// End setting of the function =================== 

//set all register pins to LOW
void Expin(int Expinc){
 switch (Expinc) {
    case 0: 
      pinMode(SER_Pin, OUTPUT);
      pinMode(RCLK_Pin, OUTPUT);
      pinMode(SRCLK_Pin, OUTPUT);
      for(int i = numOfRegisterPins - 1; i >=  0; i--){
        registers[i] = LOW;
      }
      Expin(2);
    break;
    case 1:  
      for(int i = numOfRegisterPins - 1; i >=  0; i--){
      registers[i] = LOW;
      }
      Expin(2);
    break;
    case 2:  //Set and display registers
      //Only call AFTER all values are set how you would like (slow otherwise)
      digitalWrite(RCLK_Pin, LOW);
      for(int i = numOfRegisterPins - 1; i >=  0; i--){
        digitalWrite(SRCLK_Pin, LOW);
        int val = registers[i];
        digitalWrite(SER_Pin, val);
        digitalWrite(SRCLK_Pin, HIGH); 
      }
    digitalWrite(RCLK_Pin, HIGH); 
    break;
    } 
} 
//set an individual pin HIGH or LOW
void setExtPin(int index, int value){
  registers[index] = value;
}
 
